// GPanelSizeEx1.java
// 4 windows, each has its own size

import java.awt.Color;
import ch.aplu.util.*;

class GPanelSizeEx1
{
  GPanel p1 = new GPanel(new Size(300, 200));
  GPanel p2 = new GPanel(new Size(400, 600));
  GPanel p3 = new GPanel(new Size(400, 500), "p3", null, 0, 10, 0, 10, true);
  GPanel p4 = new GPanel(new Size(401, 401), "p4", null, 0, 1, 0, 1, true);

  GPanelSizeEx1()
  {
    draw1(p1);
    draw2(p2);
    draw3(p3);
    draw4(p4);
  }

  void draw1(GPanel p)
  {
    p.line(0, 0, 1, 0);
    p.line(1, 0, 1, 1);
    p.line(1, 1, 0, 1);
    p.line(0, 1, 0, 0);

    p.line(0, 0, 1, 1);
    p.line(0, 1, 1, 0);
  }

  void draw2(GPanel p)
  {
    for (int i = 0; i < 50; i++)
    {
      float r = (float)Math.random();
      float g = (float)Math.random();
      float b = (float)Math.random();
      p.color(new Color(r, g, b));
      double x1 = Math.random();
      double y1 = Math.random();
      double x2 = Math.random();
      double y2 = Math.random();
      double x3 = Math.random();
      double y3 = Math.random();
      p.fillTriangle(x1, y1, x2, y2, x3, y3);
    }
  }

  void draw3(GPanel p)
  {
    int i, k;
    for (i = 0; i <= 10; i++)
      for (k = 0; k <= 10; k++)
        p.line(i, 0, k, 10);
    for (i = 0; i <= 10; i++)
      for (k = 0; k <= 10; k++)
        p.line(0, i, 10, k);
  }

  void draw4(GPanel p)
  {
    p.window(0, 400, 0, 400);
    for (int y = 0; y <= 255; y++)
       for (int x = 0; x <= 255; x++)
         if (( x & y ) == 0)
           p.point(x + 30, y + 30);
  }

  public static void main(String[] args)
  {
    new GPanelSizeEx1();
  }
}
