// GenPath.java
// Example of GeneralPath

import ch.aplu.util.*;
import java.awt.geom.*;

class GenPath
{
  GPanel p = new GPanel(-10, 10, -10, 10);

  GenPath()
  {
    GeneralPath square = createSquare(6);
    p.generalPath(square);
    GeneralPath tri = createTriangle(2);
    p.fillGeneralPath(tri);
    rotateFigure(square, 45, 0, 0);
    p.generalPath(square);
  }

  GeneralPath createSquare(int size)
  {
    GeneralPath gp = new GeneralPath();
    gp.moveTo(0, 0);
    gp.lineTo(size, 0);
    gp.lineTo(size, size);
    gp.lineTo(0, size);
    gp.closePath();
    return gp;
  }

  GeneralPath createTriangle(int size)
  {
    GeneralPath gp = new GeneralPath();
    gp.moveTo(0, 0);
    gp.lineTo(size, 0);
    gp.lineTo(size / 2, size);
    gp.closePath();
    return gp;
  }

  void translateFigure(GeneralPath gp, int dx, int dy)
  {
    AffineTransform t = new AffineTransform();
    t.translate(dx, dy);
    gp.transform(t);
  }

  void rotateFigure(GeneralPath gp, double angle,
                    int xCenter, int yCenter)
  {
    AffineTransform t = new AffineTransform();
    t.rotate(angle, xCenter, yCenter);
    gp.transform(t);
  }

  void scaleFigure(GeneralPath gp, double xScale,
                   double yScale)
  {
    AffineTransform t = new AffineTransform();
    t.scale(xScale, yScale);
    gp.transform(t);
  }

  void shearFigure(GeneralPath gp, double xShear,
                   double yShear)
  {
    AffineTransform t = new AffineTransform();
    t.shear(xShear, yShear);
    gp.transform(t);
  }

  public static void main(String[] args)
  {
    new GenPath();
  }
}
