// MonteCarlo.java
// Berechnung der Zahl PI mit fallenden Regentropfen

import ch.aplu.util.*;
import java.awt.*;

class MonteCarlo
{
  GPanel p = new GPanel(-0.5, 1.5, -0.5, 1.5);
  double n;  // Number of trials
  double hits;  // Number of hits inside circle
  double pi;

  MonteCarlo()
  {
    while (true)
    {
      init();
      InputDialog id = new InputDialog("Monte Carlo",
                                       "Anzahl Punkte");
      Double nn = id.getDouble();
      if (nn == null)
        System.exit(0);
      else
      {
        n = nn.doubleValue();
        p.clear();
        init();
        simulate();
        pi = 4 * hits / n;
        p.color(Color.black);
        p.move(0, -0.2);
        p.text("Die Zahl PI ist " + pi);
      }
    }
  }

  void init()
  {
    p.pos(0.5, 0.5);
    p.rectangle(1, 1);
    p.pos(0, 0);
    p.arc(1, 0, 90);
  }

  void simulate()
  {
    double zx, zy;
    hits = 0;
    for (int i = 0; i < n; i++)
    {
      zx = Math.random();
      zy = Math.random();

      if (zx * zx + zy * zy < 1)
      {
        hits += 1;
        p.color(Color.red);
      }
      else
      {
        p.color(Color.green);
      }
      p.point(zx, zy);
    }
  }

  public static void main(String[] args)
  {
    new MonteCarlo();
  }
}
