// StringBuilderEx1.java

import ch.aplu.util.*;

public class StringBuilderEx1
{
  private static StringBuffer getStringBuffer(String text,
                                              int rounds)
  {
    StringBuffer sbuf = new StringBuffer(text.length() *
                                         rounds);
    for (int i = 0; i < rounds; i++)
      sbuf.append(text);
    return sbuf;
  }

  private static StringBuilder getStringBuilder(String text,
          int rounds)
  {
    StringBuilder sbd = new StringBuilder(text.length() *
                                          rounds);
    for (int i = 0; i < rounds; i++)
      sbd.append(text);
    return sbd;
  }

  public static void main(String[] args)
  {
    String text = "foobar";
    int rounds = 1000000;
    LoResTimer timer = new LoResTimer();
    double totTime1 = 0;
    double totTime2 = 0;
    Console.printf(
      "      StringBuffer (s)   StringBuilder (s)\n");
    for (int i = 0; i < 5; i++)
    {
      timer.start();
      StringBuffer sbuf = getStringBuffer(text, rounds);
      timer.stop();
      double time1 = timer.getTime() / 1E6;
      totTime1 += time1;

      timer.start();
      StringBuilder sbd = getStringBuilder(text, rounds);
      timer.stop();
      double time2 = timer.getTime() / 1E6;
      totTime2 += time2;
      Console.printf("%3d. %10.3f %18.3f\n", i + 1, time1,
                     time2);
    }
    Console.printf("\nMittelwerte:\n");
    Console.printf("     %10.3f %18.3f (%2.0f%%)\n",
                   totTime1 / 5, totTime2 / 5,
                   totTime2 / totTime1 * 100);
  }
}
