// EnumEx2.java

import java.awt.event.*;
import javax.swing.*;
import ch.aplu.turtle.*;
import ch.aplu.util.*;

public class EnumEx2
{
  private class ButtonActionAdapter implements ActionListener
  {
    public void actionPerformed(ActionEvent evt)
    {
      Object source = evt.getSource();
      if (source == runButton)
      {
        state = State.RUNNING;
        Monitor.wakeUp();
      }
      if (source == stopButton)
        state = State.STOPPED;
      if (source == quitButton)
      {
        state = State.QUITTING;
        Monitor.wakeUp();
      }
    }
  }

  private enum State {STOPPED, RUNNING, QUITTING};
  private State state = State.STOPPED;

  private JButton runButton = new JButton("Run");
  private JButton stopButton = new JButton("Stop");
  private JButton quitButton = new JButton("Quit");
  private Turtle t = new Turtle();

  public EnumEx2()
  {
    ButtonActionAdapter adapter = new ButtonActionAdapter();
    runButton.addActionListener(adapter);
    stopButton.addActionListener(adapter);
    quitButton.addActionListener(adapter);

    t.getPlayground().add(runButton);
    t.getPlayground().add(stopButton);
    t.getPlayground().add(quitButton);
    t.getPlayground().validate();

    while (state != State.QUITTING)  // Ereignisschleife
    {
      switch(state)
      {
        case STOPPED:
          Monitor.putSleep();
          break;

        case RUNNING:
          t.forward(10).left(10);
          break;
      }
    }
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new EnumEx2();
  }
}

