// EnumEx3.java

import static ch.aplu.util.Console.*;

class EnumEx3
{
  public enum Planet
  {
    MERKUR (3.303e+23, 2.4397e6),
    VENUS (4.869e+24, 6.0518e6),
    ERDE (5.976e+24, 6.37814e6),
    MARS (6.421e+23, 3.3972e6),
    JUPITER (1.9e+27, 7.1492e7),
    SATURN (5.688e+26, 6.0268e7),
    URANUS (8.686e+25, 2.5559e7),
    NEPTUN (1.024e+26, 2.4746e7),
    PLUTO (1.27e+22, 1.137e6);

    private final double mass; // in Kilogramm
    private final double radius; // in Meter

    // Gravitationskonstante (in m3 kg-1 s-2)
    public static final double G = 6.67300E-11;

    // Konstruktor
    Planet(double mass, double radius)
    {
      this.mass = mass;
      this.radius = radius;
    }

    // Akzessoren
    private double mass()
    {
      return mass;
    }

    private double radius()
    {
      return radius;
    }

    // Fallbeschleunigung
    double g()
    {
      return G * mass / (radius * radius);
    }

    // Gewicht auf Oberflaeche
    double surfaceWeight(double mass)
    {
      return mass * g();
    }
  }

  public static void main(String[] args)
  {
    printf("Welches ist deine Masse in kg? ");
    double myMass = readDouble();
    for (Planet p : Planet.values())
      printf("Dein Gewicht auf %7s ist %8.2f N%n",
              p, p.surfaceWeight(myMass));
  }
}
