// TimeEx1.java
// J2SE 1.5:
//   Use generics for Vector
//   No need to cast elementAt()
//   Use for-each loop

import ch.aplu.util.*;
import ch.aplu.turtle.*;
import java.util.*;
import java.awt.Color;
import java.awt.geom.*;

public class TimeEx1 implements TimerListener
{
  private Turtle mother = new Turtle();
  private Vector<Turtle> dancingFamily = new Vector<Turtle>();
  private LoResAlarmTimer timer =
    new LoResAlarmTimer(3000000);

  public TimeEx1()
  {
    timer.addTimerListener(this);
    timer.start();
    while (true)
    {
      for (Turtle t : dancingFamily)
        t.right(10);
    }
  }

  public boolean timeElapsed()
  {
    // Create turtle with random color
    Turtle child =
      new Turtle(mother,
                 new Color((float)Math.random(),
                           (float)Math.random(),
                           (float)Math.random()));
    child.heading(360 * Math.random());
    child.forward(100);
    dancingFamily.add(child);
    return true;
  }

  public static void main(String[] args)
  {
    new TimeEx1();
  }
}
