// MouseEx3.java

import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import ch.aplu.util.*;

public class MouseEx3 extends GPanel
{
  private Point2D.Double anchor;
  private Point2D.Double pt;

  private class MyMouseInputAdapter extends MouseInputAdapter
  {
    public void mousePressed(MouseEvent evt)
    {
      getPane().setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
      anchor = pt = toWindow(evt.getPoint());
      setXORMode(Color.white);
    }

    public void mouseReleased(MouseEvent evt)
    {
      getPane().setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      setPaintMode();
      color(Color.black);
      line(anchor, pt); // Draw definitely
    }

    public void mouseDragged(MouseEvent evt)
    {
      color(Color.red);
      line(anchor, pt); // Erase line
      pt = toWindow(evt.getPoint());
      line(anchor, pt); // Draw line
    }
  }

  public MouseEx3()
  {
    text("Press and drag to create a rubberband line");
    MyMouseInputAdapter mia = new MyMouseInputAdapter();
    addMouseListener(mia);
    addMouseMotionListener(mia);
  }

  public static void main(String[] args)
  {
    new MouseEx3();
  }
}
