// SimEx2.java
// Vertikaler Wurf ohne Luftwiderstand

import ch.aplu.util.*;
import java.awt.Color;

class SimEx2 extends GPanel
{
  SimEx2()
  {
    final double g = 9.81; // Erdbeschleunigung im m/s^2
    final double d = 0.1;  // Zeitschritt in s
    final double x0 = 0;   // Anfangskoordinate in m
    final double v0 = 20;  // Anfangsgeschwindigkeit in m/s

    double a = -g;                // Beschleunigung
    double t = 0, x = x0, v = v0; // Anfangsbedingungen
    double xt = 0, vt = v0;       // Theoretische Werte

    title(
      "Vertikaler Wurf Vergleich mit Theorie");
    window(-1, 10, -250, 50);

    // Koordinatensystem
    line(-1, 0, 10, 0);   // x-Achse
    line(0, -250, 0, 50); // y-Achse   move(0, 0);

    while (t < 10)
    {
      if (t == 0)
        move(t, x);
      else
        draw(t, x);
      x = x + v * d; // Neue Koordinate
      v = v + a * d; // Neue Geschwindigkeit
      t = t + d;     // Neue Zeit
    }

    // Theoretisch
    t = 0;
    color(Color.green);
    while (t < 10)
    {
      xt = v0 * t - g / 2 * t * t;
      if (t == 0)
        move(t, xt);
      else
        draw(t, xt);
      t = t + d;
    }
  }


  public static void main(String[] args)
  {
    new SimEx2();
  }
}
