// WindowEx3.java

import ch.aplu.util.*; // for GWindow
import javax.swing.*; // for JPanel
import java.awt.*; // for Graphics
import java.awt.geom.*; // for Line2D
import java.awt.image.*; // for BufferedImage

public class WindowEx3 extends JPanel
{
  private GWindow w = new GWindow();

  public WindowEx3()
  {
    w.setWinSize(400, 400);
    w.setWindow(0, 10, 0, 10);
    w.showComponent(this);
    drawFigure();
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    BufferedImage bi = w.getBufferedImage();
    Graphics2D g2D = (Graphics2D)g;
    g2D.drawImage(bi, 0, 0, this);
  }

  private void drawFigure()
  {
    GeneralPath gp = new GeneralPath();
    gp.moveTo(0, 0);
    gp.lineTo(10, 0);
    gp.lineTo(10, 10);
    gp.lineTo(0, 10);
    gp.closePath();
    gp.lineTo(10, 10);
    gp.moveTo(0, 10);
    gp.lineTo(10, 0);

    Graphics2D g2D = w.getOffG2D();
    g2D.draw(w.toUser(gp));
    repaint();
  }

  public static void main(String[] args)
  {
    new WindowEx3();
  }
}
