// Conett.java
// Spektrum der Wissenschaft x-1986

import ORG.netlib.math.complex.Complex;
import ch.aplu.util.*;
import java.awt.Color;

public class Conett
{
  private double reMin = 0;
  private double reMax = 50;
  private double imMin = 0;
  private double imMax = 80;
  private double step = (imMax - imMin) / 1000.0;
  private Complex reStep = new Complex(step, 0);
  private Complex imStep = new Complex(0, step);
  private GPanel p = new GPanel(reMin, reMax, imMin, imMax);

  public Conett()
  {
    p.enableRepaint(false);
    p.color(Color.blue);
    Complex z = new Complex(reMin, imMin);
    int c;

    while (z.im() < imMax)
    {
      z = new Complex(reMin, z.im());
      while (z.re() < reMax)
      {
        c = (int)Math.floor(z.norm());
        if (c % 2 == 0)
          p.point(z.re(), z.im());
        z = z.add(reStep);
      }
      z = z.add(imStep);
    }
    p.repaint();
  }

  public static void main(String[] args)
  {
    new Conett();
  }
}
