// PrintEx4.java
// Select drawing or printing with menue

import javax.swing.*;
import java.awt.event.*;
import ch.aplu.util.*;

public class PrintEx4 implements ActionListener, GPrintable
{
  private interface State
  {
    int IDLE = 0;
    int DRAWING = 1;
    int PRINTING = 2;
    int EXITING = 3;
  }

  private GPanel p = new GPanel(setMenu(), 0, 8, 0, 8);
  private JMenuItem drawItem, printItem, exitItem;
  private int state = State.IDLE;

  public PrintEx4()
  {
    while (state != State.EXITING)
    {
      switch (state)
      {
        case State.IDLE:
          Monitor.putSleep();
          break;
        case State.DRAWING:
          draw();
          state = State.IDLE;
          break;
        case State.PRINTING:
          p.print(this);
          state = State.IDLE;
          break;
      }
    }
    System.exit(0);
  }

  public void draw()
  {
    for (int i = 0; i < 8; i++)
      for (int j = 0; j < 8; j++)
        if ((i + j) % 2 == 0)
          p.fillRectangle(i, j, i + 1, j + 1);

  }

  private JMenuBar setMenu()
  {
    JMenu fileMenu = new JMenu("File");
    drawItem = new JMenuItem("Draw");
    fileMenu.add(drawItem);
    drawItem.addActionListener(this);
    printItem = new JMenuItem("Print");
    fileMenu.add(printItem);
    printItem.addActionListener(this);
    exitItem = new JMenuItem("Exit");
    fileMenu.add(exitItem);
    exitItem.addActionListener(this);

    JMenuBar menuBar = new JMenuBar();
    menuBar.add(fileMenu);

    return menuBar;
  }

  public void actionPerformed(ActionEvent e)
  {
    if (e.getSource() == drawItem)
      state = State.DRAWING;
    if (e.getSource() == printItem)
      state = State.PRINTING;
    if (e.getSource() == exitItem)
      state = State.EXITING;

    Monitor.wakeUp();
  }

  public static void main(String[] args)
  {
    new PrintEx4();
  }
}
