// CtorEx10.java

import ch.aplu.util.*;

class Fraction
{
  private int numerator;
  private int denominator;

  public Fraction(int numerator, int denominator)
          throws NumberFormatException
  {
    this.numerator = numerator;
    this.denominator = denominator;
    if (denominator == 0)
      throw new NumberFormatException("denominator is zero");
  }

  public String toString()
  {
    if (denominator == 0)
      return "NaF"; // Not a Fraction
    return Integer.toString(numerator) + "/" +
           Integer.toString(denominator);
  }
}

public class CtorEx10 extends Console
{
  public CtorEx10()
  {
    while (true)
    {
      Fraction p = readFraction();
      if (p != null)
        println("Ok. Bruch p = " + p);
    }
  }

  public Fraction readFraction()
  {
    Fraction p = null;
    try
    {
      print("Zaehler: ");
      int num = readInt();
      print("Nenner: ");
      int denom = readInt();
      p = new Fraction(num, denom);
    }
    catch (NumberFormatException ex)
    {
      println("Kein Bruch");
    }
    return p;
  }

  public static void main(String[] args)
  {
    new CtorEx10();
  }
}
