// GuiEx7.java

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import ch.aplu.util.*;

public class GuiEx7
{
  private Console console = new Console();
  private JDialog jDialog = new JDialog(console.getFrame(),
                                        "Input");
  private JPanel contentPane;
  private JLabel jLabel = new JLabel();
  private JTextField jTextField = new JTextField();
  private JButton jButton = new JButton();

  public GuiEx7()
  {
    init();
    jDialog.setVisible(true);
    jButton.requestFocus();
  }

  private void init()
  {
    contentPane = (JPanel)jDialog.getContentPane();
    contentPane.setLayout(new FlowLayout());

    jLabel.setText("Gebe einen Integer ein (1..100)");
    jTextField.setColumns(10);
    jTextField.setText("20");
    jButton.setText("Apply");
    contentPane.add(jLabel);
    contentPane.add(jTextField);
    contentPane.add(jButton);
    jDialog.setSize(250, 100);
    jDialog.setResizable(false);
    jDialog.setDefaultCloseOperation(
      WindowConstants.DO_NOTHING_ON_CLOSE);
    jDialog.setLocationRelativeTo(console.getFrame());

    jButton.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        String value = jTextField.getText().trim();
        IntegerValidator iv = new IntegerValidator(1, 100);
        if (!iv.isValid(value))
        {
          console.println("Illegal entry");
          return;
        }
        int n = Integer.parseInt(value);
        console.println("Primzahlen <= " + n + " :");
        for (int i = 1; i <= n; i++)
          if (isPrime(i))
            console.println(i);
      }
    });
  }

  private boolean isPrime(int n)
  {
    for (int i = 2; i * i <= n + 1; i++)
      if (n % i == 0)
        return false;
    return true;
  }

  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(

      //        UIManager.getCrossPlatformLookAndFeelClassName()
      //        UIManager.getSystemLookAndFeelClassName()
      "javax.swing.plaf.metal.MetalLookAndFeel"

      //        "com.sun.java.swing.plaf.motif.MotifLookAndFeel"
      //        "com.sun.java.swing.plaf.windows.WindowsLookAndFeel"
      //        "javax.swing.plaf.mac.MacLookAndFeel"
      );

    }
    catch (Exception ex)
    {
      System.err.println("Couldn't use the system " +
                         "look and feel: " + ex);
    }

    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new GuiEx7();
      }
    });
  }
}
