// FourierSeries.java

import ch.aplu.util.*;
import java.awt.Color;

class FourierSeries
{
  private int type;
  private int order;
  private Function[] func = {new Function.F0(),
                             new Function.F1(),
                             new Function.F2(),
                             new Function.F3()};

  public FourierSeries(int type, int order)
  {
    this.type = type;
    this.order = order;
  }

  public void drawSum(GPanel panel, double xmin, double xmax)
  {
    panel.lineWidth(2);
    double step = 0.01;
    double x;
    double y;

    panel.color(Color.black);
    for (x = xmin; x < xmax; x += step)
    {
      y = 0;
      for (int n = 1; n <= order; n++)
        y += func[type].a(n) * Math.sin(n * x);
      if (x == 0)
        panel.move(0, y);
      else
        panel.draw(x, y);
    }
  }

  public void drawElements(GPanel panel, double xmin,
                           double xmax)
  {
    double step = 0.01;
    double x;
    double y;

    panel.color(Color.red);
    for (int n = 1; n <= order; n++)
    {
      for (x = xmin; x < xmax; x += step)
      {
        y = func[type].a(n) * Math.sin(n * x);
        if (x == 0)
          panel.move(0, y);
        else
          panel.draw(x, y);
      }
    }
  }
}
