// Function.java

public interface Function
{
  public double a(int n);

  class F0 implements Function

  // Ramp
  {
    public double a(int n)
    {
      return 1.0 / n;
    }
  }

  class F1 implements Function

  // Rectangle
  {
    public double a(int n)
    {
      if (n % 2 == 0)
        return 0;
      return 1.0 / n;
    }
  }

  class F2 implements Function

  // Triangle
  {
    public double a(int n)
    {
      double sign = 0;
      if (n % 4 == 1)
        sign = 1.0;
      if (n % 4 == 3)
        sign = -1.0;
      return sign / (n * n);
    }
  }

  class F3 implements Function

  // Equal harmonics
  {
    public double a(int n)
    {
      return 0.2;
    }
  }
}
