// ThreadEx4.java

import ch.aplu.util.*;

class Clerk
{
  private int id = 0;

  public int getId()
  {
    return id;
  }

  public void setId(int id)
  {
    this.id = id;
  }
}

class Person extends Thread
{
  private Clerk myClerk;

  Person(Clerk clerk)
  {
    myClerk = clerk;
  }

  public void run()
  {
    int id = 0;
    while (id < 3)
    {
      //     synchronized (myClerk)
      {
        id = myClerk.getId();
        System.out.print(getName() + " -> ");
        System.out.print("Got id: " + id);
        System.out.println(" - thinking about... ");
        try
        {
          sleep(1000);
        }
        catch (InterruptedException ex) {}
        System.out.print(getName() + " -> ");
        System.out.println("OK. Increase and give it back.");
        myClerk.setId(id + 1);
      }
    }
  }
}

public class ThreadEx4
{
  private Clerk clerk = new Clerk();

  public ThreadEx4()
  {
    Person p1 = new Person(clerk);
    Person p2 = new Person(clerk);

    new Thread(p1).start();
    new Thread(p2).start();
  }

  public static void main(String[] args)
  {
    Console.init();
    new ThreadEx4();
  }
}
