// ThreadEx7a.java

import ch.aplu.util.*;

public class ThreadEx7a implements TimerListener
{
  private LoResAlarmTimer timer1 =
      new LoResAlarmTimer(1000000, true);
  private LoResAlarmTimer timer2 =
      new LoResAlarmTimer(1500000, true);
  private int count = 0;
  private boolean inCallback = false;

  public ThreadEx7a()
  {
    System.out.println(Thread.currentThread().getName());
    timer1.addTimerListener(this);
    timer2.addTimerListener(this);
    while (true)
      Console.delay(10);
  }

  synchronized public boolean timeElapsed()
  {
    if (inCallback)
    {
      System.out.println("in callback");
      return true;
    }
    inCallback = true;
    String s = Thread.currentThread().getName();
    System.out.println("in:  " + s);
    System.out.println(++count);
    for (int i = 0; i < 10000; i++)
    {
      Math.sin(i);
      Thread.currentThread().yield();
    }
    System.out.println("out: " + s);
    inCallback = false;
    return true;
  }

  public static void main(String[] args)
  {
    Console.init();
    new ThreadEx7a();
  }
}
