// ParseHtml.java

import java.io.*;
import java.net.*;
import ch.aplu.util.Console;

public class ParseHtml extends Console
{
  private String host = "www.google.com";
  private int port = 80;
  private String startTag = "of about <b>";
  private String endTag = "</b>";

  public ParseHtml()
  {
    ByteArrayOutputStream reply = new ByteArrayOutputStream();
    PrintWriter writer = new PrintWriter(reply, true);
    try
    {
      while (true)
      {
        print("Suchwort: ");
        String searchString = Console.readLine();

        // Send client request
        Socket socket = new Socket(host, port);
        PrintWriter out =
          new PrintWriter(socket.getOutputStream());
        String httpMsg = "GET /search?q=" + searchString +
                         " HTTP/1.0\r\n\r\n";
        out.print(httpMsg);
        out.flush();

        // Get server response
        reply.reset();
        BufferedReader in = new BufferedReader(
                              new InputStreamReader(
                                socket.getInputStream()));
        String line;
        while ((line = in.readLine()) != null)
          writer.println(line);

        // Parse response
        String dataStr = reply.toString();
        String nbHits = "0";
        int startIndex = dataStr.indexOf(startTag, 0) +
                         startTag.length();
        if (startIndex > -1)
        {
          int endIndex = dataStr.indexOf(endTag, startIndex);

          if (endIndex - startIndex < 15) // For security
            nbHits = dataStr.substring(startIndex, endIndex);
        }
        println("Trefferzahl: " + nbHits);

        // Release resources
        socket.close();
        in.close();
        out.close();
      }
    }
    catch (IOException ex) {}
  }

  public static void main(String[] args)
  {
    new ParseHtml();
  }
}
