// Telnet.java

import java.io.*;
import java.net.*;
import ch.aplu.util.Console;

public class Telnet extends Console
{
  private Socket socket;

  // --------------- Inner class ---------------------------
  class InputThread extends Thread
  {
    public void run()
    {
      BufferedReader in = null;
      try
      {
        in = new BufferedReader(
          new InputStreamReader(socket.getInputStream()));
        String line;
        while ((line = in.readLine()) != null)
          println(line);
      }
      catch (IOException ex) {}
      try
      {
        if (in != null)
          in.close();
        if (socket != null)
          socket.close();
      }
      catch (IOException ex) {}
    }
  }

  // --------------- End of inner class --------------------

  public Telnet()
  {
    print("Host? ");
    String host = readLine();
    print("Port: ");
    int port = readInt();
    try
    {
      socket = new Socket(host, port);
      PrintWriter out =
        new PrintWriter(socket.getOutputStream());
      new InputThread().start();
      println("Verbunden mit " + host + " am Port " + port);

      while (!socket.isClosed())
      {
        String line = Console.readLine();
        out.print(line);
        out.print("\r\n"); // Line terminator is <cr><lf>
        out.flush();
      }
      println("\nVerbindung unterbrochen.");
      println("Irgendeine Taste zum Beenden...");
      while (!kbhit()) {}
      System.exit(0);
    }
    catch (UnknownHostException ex)
    {
      println("Verbindungsaufnahme misslungen.");
    }
    catch (SocketException ex)
    {
      println("Verbindungsaufnahme misslungen.");
    }
    catch (IOException ex)
    {
      ex.printStackTrace();
    }
  }

  public static void main(String[] args)
  {
    new Telnet();
  }
}
