// TurtleRobot.java
// Set portName as appropriate

import ch.aplu.turtle.*;
import javax.comm.*;
import java.io.*;
import java.util.*;

public class TurtleRobot extends Turtle
        implements SerialPortEventListener
{
  private final String portName = "COM1";
  private double direction = 0;
  private double step = 3;
  private boolean go = false;
  private PrintStream ps;
  private BufferedReader br;

  public TurtleRobot() throws IOException
  {
    setTitle("Turtle Robot");
    wrap();
    speed(100);
    SerialPort port = PortCreator.openPort(portName);
    if (port == null)
    {
      System.out.println("Cannot open Com port");
      System.exit(1);
    }
    ps = new PrintStream(port.getOutputStream());
    br = new BufferedReader(
      new InputStreamReader(port.getInputStream()));
    try
    {
      port.addEventListener(this);
    }
    catch (TooManyListenersException ex) {}

    port.notifyOnDataAvailable(true);
    while (true)
    {
      if (go)
      {
        ps.println(getX() + ";" + getY());
        heading(direction);
        forward(step);
      }
    }
  }

  public void serialEvent(SerialPortEvent event)
  {
    if (event.getEventType()
            == SerialPortEvent.DATA_AVAILABLE)
    {
      try
      {
        go = true;
        String data = br.readLine();
        int k = data.indexOf(';');
        direction = Double.parseDouble(data.substring(0, k));
        step = Double.parseDouble(data.substring(k + 1));
      }
      catch (Exception ex) {}
    }
  }

  public static void main(String[] args) throws Exception
  {
    new TurtleRobot();
  }
}
