// SoundGenerator.java

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.sound.sampled.*;

public class SoundGenerator extends JFrame
        implements ActionListener
{
  private FunctionPlayer fPlayer =
    new FunctionPlayer(MyAudioFormat.getAudioFormat());
  private final JButton[] buttons = {new JButton("Sinus"),
                                     new JButton("Rechteck"),
                                     new JButton("Sgezahn"),
                                     new JButton("Schwebung"),
                                     new JButton("Sweep")};
  private final int nbButtons = buttons.length;

  public SoundGenerator()
  {
    for (int i = 0; i < nbButtons; i++)
    {
      buttons[i].addActionListener(this);
      getContentPane().add(buttons[i]);
    }

    getContentPane().setLayout(new FlowLayout());
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setTitle("Sound Generator");
    setSize(500, 70);
    setLocation(200, 100);
    setVisible(true);
  }

  private void enableButtons(boolean[] b)
  {
    for (int i = 0; i < b.length; i++)
      buttons[i].setEnabled(b[i]);
  }

  public void actionPerformed(ActionEvent evt)
  {
    Object source = evt.getSource();
    for (int i = 0; i < nbButtons; i++)
    {
      if (source == buttons[i])
      {
        fPlayer.initData(i, 3, 500, 0.3);
        try
        {
          fPlayer.start(false);  // Do not block callback method!
        }
        catch (LineUnavailableException ex)
        {
          System.out.println("Sound card not available");
          System.exit(1);
        }
      }
    }
  }

  public static void main(String args[])
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new SoundGenerator();
      }
    });
  }
}
