// GraphicsEx5.java

import java.awt.*;
import javax.swing.*;

public class GraphicsEx5 extends JFrame
{
  private JBufferedMan jbMan =
    new JBufferedMan("jman.gif", 50, 100);

  public GraphicsEx5()
  {
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    getContentPane().add(jbMan, BorderLayout.CENTER);
    pack();

    new Thread()
    {
      public void run()
      {
        animate();
      }
    }.start();
  }

  private void animate()
  {
    for (int x = 50; x < 300; x++)
    {
      jbMan.setPos(x, 100);
      delay(10);
      jbMan.repaint();
    }
  }

  private void delay(int ms)
  {
    try
    {
      Thread.currentThread().sleep(ms);
    }
    catch (InterruptedException ex) {}
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        GraphicsEx5 app = new GraphicsEx5();
        app.setVisible(true);
      }
    });
  }
}
