// GraphicsEx7.java

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class GraphicsEx7 extends JFrame
{
  private int width = 500;
  private int height = 500;
  private int totalNbNeedles = 200;

  public GraphicsEx7()
  {
    Buffon buffon = new Buffon(width, height);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    getContentPane().add(buffon);
    setResizable(false);
    pack();

    long time = new Date().getTime();
    while (buffon.getNbNeedles() < totalNbNeedles)
      buffon.throwNeedle();
    double pi = 2.0 * buffon.getNbNeedles() /
                buffon.getNbHits();
    time = new Date().getTime() - time;
    String msg = "Resultat nach " + time + " ms: Pi = " +
                 pi + " (" + totalNbNeedles + " Nadeln)";
    setTitle(msg);
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        GraphicsEx7 app = new GraphicsEx7();
        app.setVisible(true);
      }
    });
  }
}
