// GraphicsEx8.java

import java.awt.*;
import javax.swing.*;

public class GraphicsEx8 extends JFrame
{
  Picture pic = new Picture("baseball.gif");

  public GraphicsEx8()
  {
    super("Baseball");
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    getContentPane().add(pic, BorderLayout.CENTER);
    setResizable(false);
    pack();

    new Thread()
    {
      public void run()
      {
        animate();
      }
    }.start();
  }

  private void animate()
  {
    double angle = 0;
    double inc = 0.01;
    while (true)
    {
      pic.setAngle(angle);
      angle += inc;
      delay(10);
      pic.repaint();
    }
  }

  private void delay(int ms)
  {
    try
    {
      Thread.currentThread().sleep(ms);
    }
    catch (InterruptedException ex) {}
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        GraphicsEx8 app = new GraphicsEx8();
        app.setVisible(true);
      }
    });
  }
}
