// Picture.java

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;

public class Picture extends JPanel
{
  private Image image;
  private BufferedImage bi;
  private Graphics2D offG2D;
  private int imageWidth;
  private int imageHeight;
  private double angle = 0;
  private Color bkColor = Color.blue;

  public Picture(String imagePath)
  {
    image = new ImageIcon(imagePath).getImage();
    imageWidth = image.getWidth(null);
    imageHeight = image.getHeight(null);
    setPreferredSize(new Dimension(imageWidth + 100,
                                   imageHeight + 100));
    setBackground(bkColor);
    bi = new BufferedImage(imageWidth, imageHeight,
                           BufferedImage.TYPE_INT_RGB);
    offG2D = bi.createGraphics();
    offG2D.drawImage(image, 0, 0, null);
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    Graphics2D g2D = (Graphics2D)g;
    g2D.drawImage(affineTransformFilter(bi), 50, 50, null);
  }

  public BufferedImage affineTransformFilter(
          BufferedImage img)
  {
    AffineTransform at = new AffineTransform();
    at.rotate(angle, img.getWidth() / 2, img.getHeight() / 2);
    AffineTransformOp rotator =
      new AffineTransformOp(at,
                            AffineTransformOp.TYPE_BILINEAR);
    return rotator.filter(img, null);
  }

  public void setAngle(double angle)
  {
    this.angle = angle;
  }
}
