// Christmas.java

/*
HTML tag:

<applet code="Christmas.class"
             archive="aplu5.jar, christmas.jar"
             width="500" height="500"></applet>

where christmas.jar contains Christmas.class and Star.class
*/


import java.awt.*;
import javax.swing.*;
import ch.aplu.util.*;

public class Christmas extends JApplet implements Runnable
{
  private GPane p;
  private volatile boolean active = true;
  private Color bgColor = Color.blue;

  public void start()
  {
    p = new GPane();
    p.bgColor(bgColor);
    p.window(0, 500, 0, 500);
    getContentPane().add(p);
    new Thread(this).start();
  }

  public void run()
  {
    int dy = 2;
    int nbStars = 8;
    Star[] stars = new Star[nbStars];

    Color colors[] = {Color.yellow, Color.white, Color.green,
                      Color.magenta, Color.pink, Color.red,
                      Color.orange, Color.cyan};
    int mx[] = {100, 130, 200, 250, 300, 330, 370, 400};
    int my[] = {480, 100, 400, 300, 50, 150, 450, 500};
    double rotInc[] = {0.01, -0.02, 0.03, -0.02, 0.05, -0.1,
                       0.03, -0.02};
    int size;

    // Initialize
    for (int i = 0; i < nbStars; i++)
    {
      size = (int)(20 + 80 * Math.random());
      stars[i] = new Star(p, size, colors[i]);
    }
    p.enableRepaint(false);

    while (active)
    {
      for (int i = 0; i < nbStars; i++)
      {
        stars[i].turn(rotInc[i]);
        stars[i].showAt(mx[i], my[i]);
        my[i] = my[i] - dy;
        if (my[i] < -stars[i].getSize())
        {
          size = (int)(20 + 80 * Math.random());
          stars[i].setSize(size);
          my[i] = 500 + size;
        }
      }
      p.repaint();
      Console.delay(50);
      p.clear();
    }
  }

  public void stop()
  {
    p.dispose();
    active = false;
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        Christmas xmas = new Christmas();
        xmas.start();
        JFrame f = new JFrame();
        f.setTitle("Happy Christmas");
        f.setContentPane(xmas.getContentPane());
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        f.pack();
        f.setResizable(false);
        f.setVisible(true);
      }
    });
  }
}
