// JDance.java
// jman.gif must be packed into jdance.jar

/*
HTML tag:

  <applet code="JDance.class"
                archive="aplu5.jar, jdance.jar"
                width="100" height="100">
  </applet>
*/

import javax.swing.*;
import java.awt.geom.*;
import java.net.*;
import ch.aplu.util.*;

public class JDance extends JApplet implements Runnable
{
  private GPane p;
  private volatile boolean active = true;

  public void start()
  {
    p = new GPane();
    p.window(0, 100, 0, 100);
    p.enableRepaint(false);
    getContentPane().add(p);
    new Thread(this).start();
  }

  public void run()
  {
    String filename = "jman.gif";
    URL url = null;
    double x = 25;
    double y = 10;
    double count = 0;
    double step = 1;

    AffineTransform at = new AffineTransform();

    url = getClass().getResource(filename);
    p.image(url, x, y);
    p.repaint();

    while (active)
    {
      Console.delay(10); // Wait a while
      p.clear();  // Clear offscreen buffer
      p.image(url, x, y); // Copy original to offscreen buffer
      count += step;
      if (count == 10 || count == -10)
        step = -step;
      at.setToRotation(count/100.0, p.toUserX(x + 25), p.toUserY(y));
      p.applyTransform(at); // Rotate offscreen buffer
      p.repaint(); // Render on screen
    }
  }

  public void stop()
  {
    p.dispose();
    active = false;
  }
}
