// MonteCarlo.java

import java.awt.*;
import javax.swing.*;
import ch.aplu.util.*;

public class MonteCarlo extends JApplet
{
  private GPanel panel;

  public void start()
  {
    panel = new GPanel(GPanel.APPLETFRAME);
    panel.window(-0.1, 1.1, -0.1, 1.1);
    panel.title("Pi mit Regentropfen");
    simulate(0);

    while (true)
    {
      Integer nn =
        new InputDialog("Eingabe",
                        "Anzahl Regentropfen").getInt();
      if (nn == null)
      {
        panel.dispose();
        return;
      }
      simulate(nn.intValue());
    }
  }

  // stop() never called because of modal dialog in start()

  private void simulate(int drops)
  {
    double zx, zy;
    int hits = 0;

    panel.color(Color.black);
    panel.clear();
    panel.pos(0.5, 0.5);
    panel.rectangle(1, 1);
    panel.pos(0, 0);
    panel.arc(1, 0, 90);

    for (int i = 0; i < drops; i++)
    {
      zx = Math.random();
      zy = Math.random();

      if (zx * zx + zy * zy < 1)
      {
        hits += 1;
        panel.color(Color.red);
      }
      else
        panel.color(Color.green);
      panel.point(zx, zy);
    }
    if (drops != 0)
    {
      panel.color(Color.black);
      panel.move(0, -0.05);
      panel.text("Die Zahl PI ist " + 4.0 * hits / drops);
    }
  }

  public static void main(String args[])
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        MonteCarlo mc = new MonteCarlo();
        mc.start();
      }
    });
  }
}
