// ConfettiPanel.java

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;

public class ConfettiPanel extends JPanel
{
  private BufferedImage bi;
  private Graphics2D offG2D;
  private int width, height, size;
  private Color bkColor;

  ConfettiPanel(int width, int height, int size,
                Color bkColor)
  {
    this.width = width;
    this.height = height;
    this.size = size;
    this.bkColor = bkColor;
    bi = new BufferedImage(width, height,
                           BufferedImage.TYPE_INT_RGB);
    offG2D = bi.createGraphics();
    setPreferredSize(new Dimension(width, height));
    offG2D.setColor(bkColor);
    offG2D.fillRect(0, 0, width, height);
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    g.drawImage(bi, 0, 0, null);
  }

  public void draw()
  {
    int x = (int)(width * Math.random());
    int y = (int)(height * Math.random());
    int r = (int)(size * Math.random());
    Color c = new Color((int)(256 * Math.random()),
                        (int)(256 * Math.random()),
                        (int)(256 * Math.random()));
    offG2D.setPaint(c);

    // Don't clip the circles
    x = x - r < 0 ? r : x;
    x = x > width - r ? width - r : x;
    y = y - r < 0 ? r : y;
    y = y > height - r ? height - r : y;
    Ellipse2D.Double ellipse = new Ellipse2D.Double(x - r,
                                 y - r, 2 * r, 2 * r);
    offG2D.fill(ellipse);
    Rectangle rect = ellipse.getBounds();
    repaint(rect.x, rect.y, rect.width, rect.height);
  }
}
