// MySaxParser.java

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class MySAXParser extends DefaultHandler
{
  private Person person;
  private StringBuffer buf = new StringBuffer();
  private Vector data = new Vector();

  public Object[][] processURL(URL url) throws Exception
  {
    InputSource inputSource =
      new InputSource(url.openStream());
    SAXParserFactory fact = SAXParserFactory.newInstance();
    SAXParser parser = fact.newSAXParser();
    parser.parse(inputSource, this); // Execute parsing
    int nbRecords = data.size();
    int nbCols = 4;
    Object[][] persons = new Object[nbRecords][nbCols];
    for (int i = 0; i < nbRecords; i++)
      for (int k = 0; k < nbCols; k++)
        persons[i][k] = ((Person)data.get(i)).getInfo(k);
    return persons;
  }

  // ------------- Callback methods ------------------
  public void startElement(String uri, String localName,
                           String qname,
                           Attributes attributes)
  {
    buf.setLength(0);
    if (qname.equals("person"))
      person = new Person();
  }

  public void endElement(String uri, String localName,
                         String qname)
  {
    if (qname.equals("lastname"))
    {
      person.setInfo(0, buf.toString());
      return;
    }
    if (qname.equals("firstname"))
    {
      person.setInfo(1, buf.toString());
      return;
    }
    if (qname.equals("sex"))
    {
      person.setInfo(2, buf.toString());
      return;
    }
    if (qname.equals("age"))
    {
      person.setInfo(3, Integer.valueOf(buf.toString()));
      return;
    }
    if (qname.equals("person"))
    {
      data.add(person);
    }
  }

  public void characters(char[] chars, int start, int length)
  {
    buf.append(chars, start, length);
  }
}
