// State.java

public class State
{
  final static int IDLE = 0;
  final static int INIT = 1;
  final static int GO = 2;
  final static int HALT = 3;
  final static int RESET = 4;
  final static int EXIT = 5;

  private int z;

  public State(int z)
  {
    set(z);
  }

  public void set(int z)
  {
    this.z = z;
  }

  public int get()
  {
    return z;
  }

  public void next(int x)
  {
    switch (x)
    {
      case 0 : // Btn "Go"
        if (z == State.IDLE)
          z = State.INIT;
        else
          z = State.GO;
        break;

      case 1 : // Btn "Halt"
        if (z == State.GO)
          z = State.HALT;
        break;

      case 2 : // Btn "Reset"
        z = State.RESET;
        break;

      case 3 : // Btn "Exit"
        z = State.EXIT;
        break;
    }
  }
}
