// DbEx1.java

import java.sql.*;
import ch.aplu.util.*;

public class DbEx1 extends Console
{
  private final String username = ""; // Use your MySQL account name
  private final String password = ""; // Use the corresponding password

  public DbEx1()
  {
    Connection con = null;
    Statement stmt = null;
    try
    {
      println("Trying to load JDBC driver...");
      Class.forName("org.gjt.mm.mysql.Driver");
    }
    catch (ClassNotFoundException ex)
    {
      println("Unable to load driver class");
      return;
    }

    try
    {
      println("Trying to connect to MySQL database");
      println(" on localhost using database 'demo'...");
      con = DriverManager.getConnection(
        "jdbc:mysql://localhost/demo", username, password);

      println("Execute SQL statement 'SELECT * FROM buch'");
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT * FROM buch");

      println("Display result:\n");
      while (rs.next())
        println(rs.getString("autor") + ", " +
                rs.getString("titel") + ", erschienen " +
                rs.getInt("jahr") + " bei " +
                rs.getString("verlag"));

    }
    catch (SQLException ex)
    {
      println("Sorry. Got SQLException: " + ex.getMessage());
    }
    finally
    {
      try
      {
        println("\nClose connection now");
        if (con != null)
          con.close();
      }
      catch (SQLException ex) {}
    }
  }

  public static void main(String[] args)
  {
    new DbEx1();
  }
}
