// NimBean.java

package ch.aplu.beans;

public class NimBean
{
  private static final int initSticks = 15;
  private int sticks;
  private int picks;
  private boolean init;

  public NimBean()
  {
    sticks = -1;
    picks = -1;
    init = true;
  }

  public void setSticks(String sticksStr)
  {
    init = false;
    try
    {
      sticks = Integer.parseInt(sticksStr);
    }
    catch (NumberFormatException ex)
    {
      sticks = -1;
    }
    if (sticks < 0) // Error
      sticks = -1;
  }

  public void setPicks(String picksStr)
  {
    try
    {
      picks = Integer.parseInt(picksStr);
    }
    catch (NumberFormatException ex)
    {
      picks = -1;
    }
    if (picks < 1 || picks > 3) // Error
      picks = -1;
  }

  public String getSticks()
  {
    return Integer.toString(sticks);
  }

  public String getPicks()
  {
    return Integer.toString(picks);
  }

  public String getPlay()
  {
    if (init)
    {
      sticks = initSticks;
      picks = 0;
      return "Bin zum Spiel bereit!";
    }
    if (sticks == -1 || picks == -1 || sticks - picks < 0)
      return "Fehlerhafte Eingabe!";
    sticks -= picks;
    if (sticks == 0)
    {
      picks = 0;
      return "Entschuldige, ich habe gewonnen!";
    }
    if (sticks == 1)
    {
      sticks = 0;
      picks = 1;
      return "Musste das letzte wegnehmen. " +
             "Gratuliere, du hast gewonnen!";
    }
    switch (sticks % 4)
    {
      case 0 :
        picks = 3;
        sticks -= picks;
        return "Habe " + picks + " genommen. Jupii!";

      case 1 :
        picks = (int)(2 * Math.random()) + 1;
        sticks -= picks;
        return "Habe " + picks + " genommen. Autsch!";

      case 2 :
        picks = 1;
        sticks -= picks;
        return "Habe " + picks + " genommen. Jupii!";

      case 3 :
        picks = 2;
        sticks -= picks;
        return "Habe " + picks + " genommen. Jupii!";
    }
    return "";
  }

  public static void main(String[] args)
  {
    NimBean player = new NimBean();
    for (int i = 15; i > -2; i--)
    {
      for (int k = 1; k <= 3; k++)
      {
        System.out.println("Vorhanden: " + i);
        System.out.println("Person nimmt weg: " + k);
        player.setSticks(Integer.toString(i));
        player.setPicks(Integer.toString(k));
        System.out.println("Bean's Kommentar: " +
                           player.getPlay());
        System.out.println("Bleiben " + player.getSticks());
        System.out.println();
      }
    }
  }
}
